(function() {
/*
	Designed By Sharif Zamani Email is Sharifzamani@aol.com And Mobile Is 09396041240 And Webpage Is http://pasadnsg.ir
*/


var N = 624;
var M = 397;
var MATRIX_A = 0x9908b0df;   
var UPPER_MASK = 0x80000000; 
var LOWER_MASK = 0x7fffffff; 

var mt = new Array(N); 
var mti=N+1; 


function init_genrand(s)
{
    mt[0]= s >>> 0;
    for (mti=1; mti<N; mti++) {
        var s = mt[mti-1] ^ (mt[mti-1] >>> 30);
      mt[mti] = (((((s & 0xffff0000) >>> 16) * 1812433253) << 16) + (s & 0x0000ffff) * 1812433253)
      + mti;

        mt[mti] >>>= 0;

    }
}


function init_by_array(init_key, key_length)
{
    var i, j, k;
    init_genrand(19650218);
    i=1; j=0;
    k = (N>key_length ? N : key_length);
    for (; k; k--) {
        var s = mt[i-1] ^ (mt[i-1] >>> 30)
        mt[i] = (mt[i] ^ (((((s & 0xffff0000) >>> 16) * 1664525) << 16) + ((s & 0x0000ffff) * 1664525)))
          + init_key[j] + j; 
        mt[i] >>>= 0; 
        i++; j++;
        if (i>=N) { mt[0] = mt[N-1]; i=1; }
        if (j>=key_length) j=0;
    }
    for (k=N-1; k; k--) {
        var s = mt[i-1] ^ (mt[i-1] >>> 30);
        mt[i] = (mt[i] ^ (((((s & 0xffff0000) >>> 16) * 1566083941) << 16) + (s & 0x0000ffff) * 1566083941))
          - i; 
        mt[i] >>>= 0; 
        i++;
        if (i>=N) { mt[0] = mt[N-1]; i=1; }
    }

    mt[0] = 0x80000000; 
}


function genrand_int32()
{
    var y;
    var mag01 = new Array(0x0, MATRIX_A);


    if (mti >= N) { 
        var kk;

        if (mti == N+1)   
            init_genrand(5489); 

        for (kk=0;kk<N-M;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+M] ^ (y >>> 1) ^ mag01[y & 0x1];
        }
        for (;kk<N-1;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+(M-N)] ^ (y >>> 1) ^ mag01[y & 0x1];
        }
        y = (mt[N-1]&UPPER_MASK)|(mt[0]&LOWER_MASK);
        mt[N-1] = mt[M-1] ^ (y >>> 1) ^ mag01[y & 0x1];

        mti = 0;
    }

    y = mt[mti++];


    y ^= (y >>> 11);
    y ^= (y << 7) & 0x9d2c5680;
    y ^= (y << 15) & 0xefc60000;
    y ^= (y >>> 18);

    return y >>> 0;
}


function genrand_int31()
{
    return (genrand_int32()>>>1);
}


function genrand_real1()
{
    return genrand_int32()*(1.0/4294967295.0);

}


function genrand_real2()
{
    return genrand_int32()*(1.0/4294967296.0);

}


function genrand_real3()
{
    return (genrand_int32() + 0.5)*(1.0/4294967296.0);

}


function genrand_res53()
{
    var a=genrand_int32()>>>5, b=genrand_int32()>>>6;
    return(a*67108864.0+b)*(1.0/9007199254740992.0);
}

Math.randomMT = genrand_real2;
Math.randomInt32 = genrand_int32;
Math.randomInt31 = genrand_int31;
Math.randomMTUp = genrand_real1;
Math.randomMTBoth = genrand_real3;
Math.randomMT53 = genrand_res53;
Math.seedArrayMT = function(arr) { init_by_array(arr, arr.length); };
Math.seedMT = init_genrand;
})();
